//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include <shellapi.h>
#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
IsSELECT=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CreateBDEAlias()
{
AliasName=Form2->Edit1->Text;
DatabaseType=Form2->ComboBox1->Text;

char tmpdir[MAX_PATH];
GetCurrentDirectory(MAX_PATH,tmpdir);
DatabasePath=(AnsiString)tmpdir;

ShowMessage("Tworz alias BDE do bazy danych ...\nNazwa aliasu: "+AliasName+"\nTyp bazy danych: "+DatabaseType+"\ncieka: "+DatabasePath);

/* TWORZENIE ALIASU */
if (Session1->IsAlias(AliasName))
    {
    ShowMessage("Alias "+AliasName+" ju istnieje");
    return;
    };

TStringList* Opcje=new TStringList;
Opcje->Add("LANGDRIVER=Pdox ANSI Polish");
Opcje->Add("DATABASE NAME="+AliasName);
Opcje->Add("PATH="+DatabasePath);
Session1->AddAlias(AliasName,DatabaseType,Opcje);
delete Opcje;

Session1->SaveConfigFile();
/* KONIEC TWORZENIA ALIASU */
//Alias jest usowany w Form1Close

Form1->Caption=" "+AliasName+", "+DatabasePath;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
ShowMessage("Kasowanie aliasu ...");
if (!Session1->IsAlias(AliasName))
    {
    ShowMessage("Alias "+AliasName+" ju nie istnia!");
    return;
    };

Session1->DeleteAlias(AliasName);
Session1->SaveConfigFile();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
if (ComboBox1->Text.AnsiPos("SELECT")==1)
	{
    ComboBox1->Font->Color=clNavy;
    IsSELECT=true;
    }
    else
    {
    ComboBox1->Font->Color=clWindowText;
    IsSELECT=false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
if (ComboBox1->Text.IsEmpty()) return;

if (CheckBox1->Checked) Button6Click(this);

Query1->Close();
Query1->SQL->Clear();
Query1->SQL->Add(ComboBox1->Text);
if (IsSELECT) //Bardziej eleganck byaby konstrukcja try-catch opisana w "Executing a query at runtime"
	Query1->Open();
    else
    {
    Table1->Close();
    Query1->ExecSQL();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
if (!ComboBox1->Text.IsEmpty())
	{
    ListBox1->Items->Add(ComboBox1->Text);
	ComboBox1->Text="";
    }
ComboBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
ShellExecute(Handle,"open",DatabasePath.c_str(),"","",SW_NORMAL);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
ListBox1->Items->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
ListBox1->Items->Delete(ListBox1->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
if (ListBox1->ItemIndex<0) return;
int tmpItemIndex=ListBox1->ItemIndex;
ListBox1->Items->Move(ListBox1->TopIndex+ListBox1->ItemIndex,ListBox1->TopIndex+ListBox1->ItemIndex-1);
ListBox1->ItemIndex=--tmpItemIndex; //metoda Move powoduje ustalenie ItemIndex=-1
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button10Click(TObject *Sender)
{
if (ListBox1->ItemIndex<0) return;
int tmpItemIndex=ListBox1->ItemIndex;
ListBox1->Items->Move(ListBox1->TopIndex+ListBox1->ItemIndex,ListBox1->TopIndex+ListBox1->ItemIndex+1);
ListBox1->ItemIndex=++tmpItemIndex; //metoda Move powoduje ustalenie ItemIndex=-1
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button8Click(TObject *Sender)
{
if (ListBox1->Items->Count==0) return;

Query1->SQL->Clear();
Query1->SQL=ListBox1->Items;
Query1->ExecSQL(); //Efekty polece typu SELECT znajdujce si w ListBox1 nie bd widoczne
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button11Click(TObject *Sender)
{
ComboBox1->Text="";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button14Click(TObject *Sender)
{
ComboBox1->Text=ListBox1->Items->Strings[ListBox1->ItemIndex];
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button13Click(TObject *Sender)
{
Form3->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button15Click(TObject *Sender)
{
ShellExecute(Handle,"open","localsql.hlp","","",SW_NORMAL);
}
//---------------------------------------------------------------------------
